## odb-api 0.17.6

=== CMakeLists.txt ===
cmake_minimum_required( VERSION 2.8.4 FATAL_ERROR )

set( CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake;${CMAKE_CURRENT_SOURCE_DIR}/ecbuild/cmake;${CMAKE_MODULE_PATH}" )
include( ecbuild_bundle )

project( odb_api_bundle C CXX )

ecbuild_bundle_initialize()
ecbuild_bundle( PROJECT ecbuild        STASH "ecsdk/ecbuild"      TAG  2.7.3 )
ecbuild_bundle( PROJECT eckit          STASH "ecsdk/eckit"        TAG  0.18.5 )
ecbuild_bundle( PROJECT metkit         STASH "ecsdk/metkit"       TAG  0.8.0 )
ecbuild_bundle( PROJECT odb_api        STASH "odb/odb_api"        TAG  0.17.6 )

if( ENABLE_ODB )
ecbuild_bundle( PROJECT odb            STASH "odb/odb"            TAG 1.0.8 )
ecbuild_bundle( PROJECT odb-tools      STASH "odb/odb-tools"      TAG 0.17.1 )
endif()

ecbuild_bundle_finalize()

=== ecbuild/CMakeLists.txt ===
############################################################################################
# cmake options:
#
#       -DCMAKE_INSTALL_PREFIX=/path/to/install

cmake_minimum_required( VERSION 2.8.4 FATAL_ERROR )

project( ecbuild C )

set( CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH} )

include( ecbuild_system )

###############################################################################
# local project

ecbuild_declare_project()

configure_file( cmake/ecbuild_version.h.in ${CMAKE_BINARY_DIR}/ecbuild_version.h  )

ecbuild_add_option( FEATURE INSTALL
                    DEFAULT OFF
                    DESCRIPTION "Wether to install ecbuild files" )
# contents

ecbuild_add_resources(  TARGET ${PROJECT_NAME}_description_files
                        SOURCES_PACK
                            INSTALL
                            AUTHORS
                            NOTICE
                            LICENSE
                            COPYING
)

add_subdirectory( bin )
add_subdirectory( share )
add_subdirectory( cmake )
add_subdirectory( doc )

install( DIRECTORY cmake DESTINATION ${INSTALL_DATA_DIR} PATTERN "CMakeLists.txt" EXCLUDE )

############################################################################################
# finalize

ecbuild_install_project( NAME ${PROJECT_NAME} )

ecbuild_print_summary()

=== eckit/CMakeLists.txt ===
########################################################################################################################
#
#   eckit - ECMWF C++ Toolkit
#
########################################################################################################################

cmake_minimum_required( VERSION 2.8.11 FATAL_ERROR )

project( eckit CXX )

set( CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild/cmake")

include( ecbuild_system NO_POLICY_SCOPE )

ecbuild_requires_macro_version( 2.4 )

set( PERSISTENT_NAMESPACE "eckit" CACHE INTERNAL "" ) # needed for generating .b files for persistent support

###############################################################################
# local project

ecbuild_declare_project()

###############################################################################
# some variables/options of this project

### C++11 compiler flag

ecbuild_add_option( FEATURE CXX11
                    DEFAULT OFF
                    DESCRIPTION "Use C++11 compiler flag" )

### Experimental features

ecbuild_add_option( FEATURE EXPERIMENTAL
                    DEFAULT ON
                    DESCRIPTION "Experimental features Armadillo, CUDA, MKL, ViennaCL (not used in production)" )

### eckit::mpi

ecbuild_add_option( FEATURE MPI
                    DEFAULT ON
                    DESCRIPTION "Use system MPI libraries"
                    REQUIRED_PACKAGES "MPI COMPONENTS CXX" )

### eckit::cmd

ecbuild_add_option( FEATURE ECKIT_CMD
                    DESCRIPTION "Utilities for administration tools"
                    REQUIRED_PACKAGES "LEXYACC" )

### Eigen

ecbuild_add_option( FEATURE EIGEN
                    DESCRIPTION "Eigen linear algebra library"
                    REQUIRED_PACKAGES Eigen3 )

set_package_properties( Eigen3 PROPERTIES
                        DESCRIPTION "C++ template library for linear algebra"
                      )

if( ENABLE_EIGEN )
    # TODO: we should add here a test that we can compile Eigen without problems
    # TODO: don't use contrib just yet -- sort out the legal stuff first
    # set( ECKIT_CONTRIB_EIGEN 1 )
endif()

### Armadillo

ecbuild_add_option( FEATURE ARMADILLO
                    CONDITION HAVE_EXPERIMENTAL
                    DESCRIPTION "Armadillo linear algebra library"
                    REQUIRED_PACKAGES Armadillo )

set_package_properties( Armadillo PROPERTIES
                        DESCRIPTION "C++ linear algebra"
                      )

### LAPACK

ecbuild_add_option( FEATURE LAPACK
                    DESCRIPTION "Linear Algebra PACKage"
                    REQUIRED_PACKAGES "LAPACK QUIET" )

### OpenSSL (for SHA1)

ecbuild_add_option( FEATURE SSL
                    DESCRIPTION "OpenSSL support"
                    REQUIRED_PACKAGES OpenSSL )

ecbuild_info("OpenSSL ${OPENSSL_FOUND} ${OPENSSL_VERSION} : libs ${OPENSSL_LIBRARIES} incs ${OPENSSL_INCLUDE_DIR}")

### xxHash

ecbuild_add_option( FEATURE XXHASH
                    DESCRIPTION "Use xxHash for non-crypto hashing in data integrity checks"
                    REQUIRED_PACKAGES "xxHash QUIET" )

ecbuild_info("xxHash ${XXHASH_FOUND}  : libs ${XXHASH_LIBRARIES} incs ${XXHASH_INCLUDE_DIRS}")

#### Curl

ecbuild_add_option( FEATURE CURL
                    DESCRIPTION "Curl library for transfering data with URLs"
                    REQUIRED_PACKAGES CURL )
#### CUDA

ecbuild_add_option( FEATURE CUDA
                    CONDITION HAVE_EXPERIMENTAL
                    DESCRIPTION "CUDA GPU linear algebra operations"
                    REQUIRED_PACKAGES CUDA )

### MKL

ecbuild_add_option( FEATURE MKL
                    CONDITION HAVE_EXPERIMENTAL
                    DESCRIPTION "MKL linear algebra library"
                    REQUIRED_PACKAGES MKL )

### ViennaCL

ecbuild_add_option( FEATURE VIENNACL
                    CONDITION HAVE_EXPERIMENTAL
                    DESCRIPTION "ViennaCL OpenCL linear algebra operations"
                    REQUIRED_PACKAGES ViennaCL )

set_package_properties( ViennaCL PROPERTIES
                        DESCRIPTION "linear algebra library for computations on many-core architectures"
                        TYPE RECOMMENDED
                        PURPOSE "Dense and sparse matrix operations on OpenCL devices" )

### async io support

find_package( AIO )
set_package_properties( AIO PROPERTIES TYPE RECOMMENDED PURPOSE "support for asynchronous IO" )

### thread library ( preferably pthreads )

set( CMAKE_THREAD_PREFER_PTHREAD 1 )
find_package( Threads REQUIRED )

### Curses (for CmdApplication)

find_package( Curses REQUIRED )

### c math library, needed when including "math.h"

find_package( CMath )

###############################################################################
# checks

# check thread library is pthreads

if( NOT ${CMAKE_USE_PTHREADS_INIT} )
    message( FATAL_ERROR "Only pthreads supported - thread library found is [${CMAKE_THREAD_LIBS_INIT}]" )
endif()

# fail if we dont have bool
if( NOT EC_HAVE_CXX_BOOL )
    message( FATAL_ERROR "eckit cannot build -- c++ compiler does not support bool" )
endif()
# fail if we dont have sstream
if( NOT EC_HAVE_CXX_SSTREAM )
    message( FATAL_ERROR "eckit cannot build -- c++ compiler does not support stringstream" )
endif()

############################################################################################
# export package info

set( ECKIT_INCLUDE_DIRS   ${CMAKE_CURRENT_SOURCE_DIR}/src ${CMAKE_CURRENT_BINARY_DIR}/src )
set( ECKIT_LIBRARIES      eckit eckit_geometry eckit_linalg eckit_maths eckit_web )

if( HAVE_ECKIT_CMD)
  list( APPEND ECKIT_LIBRARIES eckit_cmd )
endif()

if( HAVE_ECKIT_MPI )
  list( APPEND ECKIT_LIBRARIES eckit_mpi )
endif()

if( HAVE_EIGEN AND ECKIT_CONTRIB_EIGEN )
  list( APPEND ECKIT_INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/contrib )
endif()

if( HAVE_EXPERIMENTAL )

  list( APPEND ECKIT_INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/src/experimental )

endif()

get_directory_property( ECKIT_DEFINITIONS COMPILE_DEFINITIONS )

############################################################################################
# sources

ecbuild_find_project_files()

include_directories( ${ECKIT_INCLUDE_DIRS} )
if( HAVE_EIGEN )
    include_directories( ${EIGEN3_INCLUDE_DIR} )
endif()

if( HAVE_CXX11 )
    ecbuild_add_cxx11_flags()
endif()

add_subdirectory( bamboo )
add_subdirectory( contrib )
add_subdirectory( doc )
add_subdirectory( src )
add_subdirectory( tests )
add_subdirectory( regressions )

ecbuild_add_resources( TARGET ${PROJECT_NAME}_top_files SOURCES
                       TODO AUTHORS README NOTICE LICENSE INSTALL ChangeLog COPYING )

############################################################################################
# finalize

foreach( _lib ${ECKIT_LIBRARIES} )
  if( TARGET ${_lib} )
    ecbuild_pkgconfig( NAME ${_lib}
                       DESCRIPTION "ECMWF C++ Toolkit - ${_lib} library"
                       URL "https://software.ecmwf.int/wiki/display/ECKIT/ecKit"
                       LIBRARIES ${_lib} )
  endif()
endforeach()

ecbuild_install_project( NAME ${PROJECT_NAME} )

ecbuild_print_summary()

=== metkit/CMakeLists.txt ===
cmake_minimum_required( VERSION 2.8.11 FATAL_ERROR )

project( metkit CXX )

set( CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild/cmake")

include( ecbuild_system NO_POLICY_SCOPE )

ecbuild_requires_macro_version( 2.0 )

### dependencies

# grib support

ecbuild_add_option( FEATURE GRIB
                    DEFAULT ON
                    DESCRIPTION "Add support for GRIB format (grib_api not supported)"
                    REQUIRED_PACKAGES "PROJECT eccodes VERSION 2.5" )

# netcdf support

ecbuild_add_option( FEATURE NETCDF
  DESCRIPTION "Support for NetCDF data"
  DEFAULT ON
  REQUIRED_PACKAGES NetCDF
  NO_TPL
)

# eckit

ecbuild_use_package( PROJECT eckit  VERSION  0.18.0 REQUIRED )

### start project

ecbuild_declare_project()

### export package info

set( METKIT_INCLUDE_DIRS   ${CMAKE_CURRENT_SOURCE_DIR}/src ${CMAKE_CURRENT_BINARY_DIR}/src )
set( METKIT_LIBRARIES      metkit )

get_directory_property( METKIT_DEFINITIONS COMPILE_DEFINITIONS )

### sources

include_directories( ${METKIT_INCLUDE_DIRS} )

add_subdirectory( src )
add_subdirectory( share )

### finalize project

ecbuild_pkgconfig( NAME metkit
                   DESCRIPTION "ECMWF Meteorological toolkit"
                   LIBRARIES metkit )

ecbuild_install_project( NAME ${PROJECT_NAME} )

ecbuild_print_summary()

=== odb_api/CMakeLists.txt ===
############################################################################################
# cmake options:
#
#       -DCMAKE_BUILD_TYPE=Debug|RelWithDebInfo|Release|Production
#       -DCMAKE_INSTALL_PREFIX=/path/to/install
#
#       -DCMAKE_MODULE_PATH=/path/to/ecbuild/cmake
#
#       -DCMAKE_C_COMPILER=gcc
#       -DCMAKE_C_COMPILER=g++
#
#       -DCMAKE_PREFIX_PATH=/path/to/any/package/out/of/place
#       -DBUILD_SHARED_LIBS=ON

cmake_minimum_required( VERSION 2.8.11 FATAL_ERROR )

project( odb_api CXX Fortran )

# Add path for custom modules
set( CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild/cmake")

include( ecbuild_system NO_POLICY_SCOPE )

ecbuild_requires_macro_version( 1.9 )

###############################################################################
# local project

ecbuild_use_package( PROJECT eckit VERSION 0.9 REQUIRED )
ecbuild_use_package( PROJECT metkit VERSION 0.3 REQUIRED )

ecbuild_declare_project()

ecbuild_add_resources( TARGET ${PROJECT_NAME}_no_odb DONT_PACK_REGEX "*.odb" )
ecbuild_add_resources( TARGET ${PROJECT_NAME}_no_oda DONT_PACK_REGEX "*.oda" )

ecbuild_dont_pack(REGEX "*.odb")
ecbuild_dont_pack(REGEX ".gdbinit")

###############################################################################
# some variables/options of this project

ecbuild_add_option( FEATURE FORTRAN
                    DESCRIPTION "whether or not to build the Fortran interface"
                    DEFAULT OFF )

ecbuild_add_option( FEATURE NETCDF
                    DESCRIPTION "whether or not to build the odb2netcdf tool"
                    DEFAULT OFF
                    REQUIRED_PACKAGES "NetCDF COMPONENTS CXX" )

ecbuild_add_option( FEATURE ODB_API_SERVER_SIDE
                    DESCRIPTION "Support for keyword SERVER_SIDE"
                    DEFAULT OFF )

ecbuild_add_option( FEATURE ODB_SERVER_TIME_FORMAT_FOUR_DIGITS
                    DESCRIPTION "ODB Server uses four digits format of time"
                    DEFAULT OFF )

if( HAVE_CXX11 )
    ecbuild_add_cxx11_flags()
else()
    if ( CMAKE_VERSION VERSION_GREATER "3.1.0" )
        set( CMAKE_CXX_STANDARD 98 )
    endif()
endif()

SET(ODB_API_SCHEMA_PATH "" CACHE STRING "Path to schema file that will be loaded before executing SQL")

if( HAVE_FORTRAN )

    set( Fortran Fortran )
    ecbuild_enable_fortran( REQUIRED MODULE_DIRECTORY ${CMAKE_BINARY_DIR}/module )

endif()

if(CMAKE_Fortran_COMPILER_ID STREQUAL "GNU")
  ecbuild_add_fortran_flags("-fPIC -ffree-line-length-none")
endif()

if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
  ecbuild_add_cxx_flags("-fPIC -Wl,--as-needed")
endif()


ecbuild_add_option( FEATURE OMP
                    DESCRIPTION "Support for OpenMP threaded parallelism"
                    REQUIRED_PACKAGES "OMP COMPONENTS CXX ${Fortran}" )

if( HAVE_OMP )
  ecbuild_enable_omp()
else()
  ecbuild_enable_ompstubs()
endif()

ecbuild_add_option( FEATURE PYTHON
                    DESCRIPTION "whether or not to build the Python interface"
                    DEFAULT OFF
                    REQUIRED_PACKAGES "Python VERSION 2.7 NO_LIBS" SWIG )

###############################################################################
# contents

set_directory_properties( PROPERTIES COMPILE_DEFINITIONS "${ECKIT_DEFINITIONS}" )

get_directory_property( ODB_API_DEFINITIONS COMPILE_DEFINITIONS )

set( ODB_API_INCLUDE_DIRS   ${CMAKE_CURRENT_SOURCE_DIR}/src ${CMAKE_CURRENT_BINARY_DIR}/src )
set( ODB_API_LIBRARIES      Odb )

if( HAVE_FORTRAN )
  list( APPEND ODB_API_INCLUDE_DIRS ${CMAKE_BINARY_DIR}/module )
  list( INSERT ODB_API_LIBRARIES 0 Odb_fortran )
endif()

add_subdirectory( src )
add_subdirectory( regressions )
add_subdirectory( tests )

############################################################################################
# finalize

ecbuild_pkgconfig( NAME ${PROJECT_NAME}
                   DESCRIPTION "ECMWF coding, decoding and processing of observational data"
                   URL "https://software.ecmwf.int/wiki/display/ODB/ODB+API"
                   LIBRARIES Odb )

ecbuild_install_project( NAME OdbAPI )

ecbuild_print_summary()

=== ecbuild/cmake/CMakeLists.txt ===
file( GLOB_RECURSE ecbuild_support_files  RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} "*" )

ecbuild_add_resources(  TARGET ${PROJECT_NAME}_ecbuild_support_files
						SOURCES_PACK
							${ecbuild_support_files} )

=== ecbuild/doc/CMakeLists.txt ===
find_package( PythonInterp )

if( PYTHONINTERP_FOUND )

  file( GLOB ECBUILD_MODULE RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}
        ${CMAKE_SOURCE_DIR}/cmake/ecbuild_*.cmake )

  add_custom_target( upload_docs COMMENT "Uploading documentation" )
  add_custom_command( TARGET upload_docs POST_BUILD
                      COMMAND ${PYTHON_EXECUTABLE} upload.py --logfile "${CMAKE_CURRENT_BINARY_DIR}/upload.log" ${ECBUILD_MODULE}
                      WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
                      COMMENT "Uploading documentation" )

endif()

=== ecbuild/share/CMakeLists.txt ===
# ecbuild_add_resources( TARGET ecbuild_share 
#	SOURCE_PACK ecmwf_license_header.txt
#	DONT_PACK_DIRS ecbuild )

install( DIRECTORY ecbuild/toolchains DESTINATION ${INSTALL_DATA_DIR} )

=== ecbuild/tools/CMakeLists.txt ===
list( APPEND ecbuild_bin_files
ecbuild
git-meld
git-mproj
check_install.sh 
apply_license.sh
license.pl )

add_custom_target( ecbuild_bin SOURCES ${ecbuild_bin_files} )

install( PROGRAMS ecbuild DESTINATION ${INSTALL_BIN_DIR} )

#	install( PROGRAMS ${ecbuild_bin_files} DESTINATION ${INSTALL_BIN_DIR} )

=== eckit/src/CMakeLists.txt ===
# (C) Copyright 1996-2017 ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation nor
# does it submit to any jurisdiction.

### sources

add_subdirectory( eckit  )

if( HAVE_EXPERIMENTAL )
  add_subdirectory( experimental )
endif()

add_subdirectory( apps )

=== eckit/tests/CMakeLists.txt ===
add_subdirectory( config   )
add_subdirectory( container )
add_subdirectory( filesystem )
add_subdirectory( geometry )
add_subdirectory( io )
add_subdirectory( large_file )
add_subdirectory( linalg )
add_subdirectory( log )
add_subdirectory( maths )
add_subdirectory( memory )
add_subdirectory( mpi )
add_subdirectory( option )
add_subdirectory( parser )
add_subdirectory( runtime )
add_subdirectory( serialisation )
add_subdirectory( testing )
add_subdirectory( thread )
add_subdirectory( types )
add_subdirectory( utils )
add_subdirectory( value )
add_subdirectory( system )

if( HAVE_EXPERIMENTAL )
  add_subdirectory( experimental )
endif()

=== metkit/src/CMakeLists.txt ===
add_subdirectory( metkit )
add_subdirectory( tools )
add_subdirectory( tests )

=== debian/changelog ===
odb-api (0.17.6-2build1) bionic; urgency=high

  * No change rebuild against openssl1.1.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 05 Feb 2018 16:51:27 +0000

odb-api (0.17.6-2) unstable; urgency=medium

  * Standards-Version: 4.1.3
  * Update VCS field to salsa.debian.org
  * Update watch file
  * Fix install paths: pkgconfig in /usr/lib/@TRIPLET/pkgconfig
     include files to /usr/include/@TRIPLET
  * Set libodb-api-bin as M-A: foreign
  * Add apache NOTICE to libodb-api-dev.docs

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 31 Jan 2018 07:15:15 +0000

odb-api (0.17.6-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 31 Dec 2017 10:56:23 +0000

odb-api (0.17.4-4) unstable; urgency=medium

  * B-D on mpi-default-dev, not libopenmpi-dev.
  * Standards-Version now 4.1.2; no changes required

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 19 Dec 2017 12:00:07 +0000

odb-api (0.17.4-3) unstable; urgency=medium

  * Change odb_api-targets-release.cmake refernces from odb -> ecmwf_odb
  * Make libodb-api-dev depend on libodb-api-bin, as the cmake scripts
    depend on the binaries bein present

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 09 Nov 2017 18:22:05 +0000

odb-api (0.17.4-2) unstable; urgency=medium

  * Delete ecbuild configuartion info from include files that break
    multi-arch usability and reproducibility
  * Rename odb -> ecmwf_odb to avoid conflict. Closes: #880890
  * Disable duplicate method in DenseMap that breaks build on 32-bit systems
    Closes:  #880966
  * Add namespace to swap call on big-endian systems. Closes: #880968

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 06 Nov 2017 17:40:48 +0000

odb-api (0.17.4-1) unstable; urgency=medium

  * New upstream release
  * Close correct bug for ITP. Closes: #873607
  * Standards-Version: 4.1.1
  * Now require libeccodes-dev >= 2.5.0
  * Add ksh depenendency for libodb-api-bin
  * Set DISABLE_OS_CHECK=On. Closes: #880681
  * Sanitise build path in cmake files for reproducibility.
  * Fix for unsigned long convert to size_t on 32-bit systems. Closes: #880680
  * Patch to find libOdb.so.0d in python module via multiarch path

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 05 Nov 2017 10:52:13 +0000

odb-api (0.17.1-1) unstable; urgency=medium

  * Initial release. (Closes: #873067)

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 01 Sep 2017 11:44:23 +0100

=== debian/control ===
Source: odb-api
Section: utils
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper (>=10),
 dh-python,
 gfortran, 
 flex,
 bison,
 cmake (>= 2.8.11), 
 libopenjp2-7-dev,
 libboost-dev (>= 1.47.0), libboost-test-dev, 
 libssl-dev,
 libncurses5-dev,
 libnetcdf-cxx-legacy-dev,
 libeccodes-tools,
 chrpath,
 doxygen,
 swig,
 libeccodes-dev (>= 2.5.0),
 mpi-default-dev,
 libeigen3-dev,
 libviennacl-dev,
 libarmadillo-dev,
 python3-all-dev,
 libnetcdf-dev
Standards-Version: 4.1.3
Homepage: https://software.ecmwf.int/wiki/display/ODBAPI
Vcs-Browser: https://salsa.debian.org:/science-team/odb-api.git
Vcs-Git: https://salsa.debian.org:/science-team/odb-api.git

Package: libodb-api-0d
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Observational Data processing API for meteorology
 ODB API is a software developed at ECMWF for encoding and processing of
 observational data. It includes a SQL filtering and statistics engine, 
 command line tools and APIs for C/C++, Fortran and Python.
 .
 ODB API works with data formats used in the ECMWF observational feedback
 archive.  Development of ODB API has been partially funded by the 
 UK Met Office.

Package: libodb-api-bin
Section: libs
Architecture: any
Multi-Arch: foreign
Depends: libodb-api-0d ( = ${binary:Version}), ${shlibs:Depends}, ${misc:Depends},
 ksh | mksh | pdksh | zsh
Description: Tools for the Observational Data Processing (ODB) API
 ODB API is a software developed at ECMWF for encoding and processing of
 observational data. It includes a SQL filtering and statistics engine, 
 command line tools and APIs for C/C++, Fortran and Python.
 .
 This package provides tools for ODB handling.
 
Package: libodb-api-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libodb-api-0d ( = ${binary:Version}), ${misc:Depends}, libodb-api-bin
Recommends: pkg-config, gfortran
Description: Observational Data processing API for meteorology
 ODB API is a software developed at ECMWF for encoding and processing of
 observational data. It includes a SQL filtering and statistics engine, 
 command line tools and APIs for C/C++, Fortran and Python.
 .
 This package provides shared libraries and headers.

Package: python3-odb-api
Section: python
Architecture: any
Multi-Arch: same
Depends: libodb-api-0d ( = ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}, ${python3:Depends}
Description: Python Observational Data processing API for meteorology
 ODB API is a software developed at ECMWF for encoding and processing of
 observational data. It includes a SQL filtering and statistics engine, 
 command line tools and APIs for C/C++, Fortran and Python.
 .
 This package provides the Python wrappers to the ODB API.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

# The magic debhelper  rule
%:
	dh $@ --buildsystem=cmake --with=python3

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
AUTOGENERATED:= libodb-api-0d.install libodb-api-dev.install libodb-api-dev.links
LIBDIR:=/usr/lib/${DEB_HOST_MULTIARCH}
DESTDIR:=$(shell pwd)/debian/tmp

CMAKE_DIR_ECKIT:=debian/tmp/usr/share/eckit/cmake
CMAKE_DIR_ODBAPI:=debian/tmp/usr/share/odb_api/cmake
INC_DIR:=debian/tmp/usr/include

CMAKE_CFLAGS:= \
		-DCMAKE_BUILD_TYPE=Release \
		-DDISABLE_OS_CHECK=ON \
		-DBUILD_SHARED_LIBS=ON \
		-DENABLE_EIGEN=ON \
		-DENABLE_NETCDF=ON \
		-DENABLE_FORTRAN=ON \
		-DENABLE_PYTHON=ON \
		-DENABLE_VIENNACL=ON \
		-DPYTHON_EXECUTABLE=/usr/bin/python3 

override_dh_auto_clean:
	rm -f $(patsubst %, debian/%, ${AUTOGENERATED})
	dh_auto_clean

override_dh_auto_configure:
	for f in ${AUTOGENERATED} ; do \
		sed -e 's%@ARCH@%${DEB_HOST_MULTIARCH}%g' < debian/$$f.in  > debian/$$f ; \
	done
	dh_auto_configure --  ${CMAKE_CFLAGS}

override_dh_auto_test:
	@echo "Skipping tests; need to disable downloads"
	# dh_auto_test ||  @echo "Ignoring test failures" 

override_dh_auto_install:
	dh_auto_install	
	for d in debian/tmp/usr/bin/* ; do \
		( chrpath -d $$d || echo "Ignoring non-ELF file errors") ; done
	chrpath -d debian/tmp/usr/lib/*.0d
	# Fix broken paths 
	cat ${CMAKE_DIR_ECKIT}/eckit-targets-release.cmake | \
		sed -e 's%$${_IMPORT_PREFIX}/bin%/usr/bin%' | \
		sed -e 	's%$${_IMPORT_PREFIX}/lib%$(LIBDIR)%' > ${CMAKE_DIR_ECKIT}/tmp
	mv ${CMAKE_DIR_ECKIT}/tmp ${CMAKE_DIR_ECKIT}/eckit-targets-release.cmake
	cat ${CMAKE_DIR_ODBAPI}/odb_api-targets-release.cmake | \
		sed -e 's%$${_IMPORT_PREFIX}/bin%/usr/bin%' | \
		sed -e 's%"/usr/bin/odb"%"/usr/bin/ecmwf_odb"%' | \
		sed -e 	's%$${_IMPORT_PREFIX}/lib%$(LIBDIR)%' > ${CMAKE_DIR_ODBAPI}/tmp
	mv ${CMAKE_DIR_ODBAPI}/tmp ${CMAKE_DIR_ODBAPI}/odb_api-targets-release.cmake
	# Sanitise paths for bit reproducibility
	cat ${CMAKE_DIR_ODBAPI}/odb_api-config.cmake | \
		sed -e 's%${CURDIR}%/build/odb-api%g' > ${CMAKE_DIR_ODBAPI}/tmp
	mv ${CMAKE_DIR_ODBAPI}/tmp ${CMAKE_DIR_ODBAPI}/odb_api-config.cmake
	# Delete files that break reproducibility, and refs from include files
	rm -f ${INC_DIR}/odb_api/odb_api_ecbuild_config.h \
		${INC_DIR}/eckit/eckit_ecbuild_config.h   \
		${INC_DIR}/metkit/metkit_ecbuild_config.h 
	grep -v odb_api_ecbuild_config.h ${INC_DIR}/odb_api/odb_api_config.h | \
		grep -v ODB_API_BINARY_DIR > ${INC_DIR}/tmp
	mv ${INC_DIR}/tmp ${INC_DIR}/odb_api/odb_api_config.h
	grep -v eckit_ecbuild_config.h ${INC_DIR}/eckit/eckit_config.h | \
		grep -v ECKIT_BUILD_DIR > ${INC_DIR}/tmp
	mv ${INC_DIR}/tmp ${INC_DIR}/eckit/eckit_config.h
	grep -v metkit_ecbuildconfig.h ${INC_DIR}/metkit/metkit_config.h > ${INC_DIR}/tmp
	mv ${INC_DIR}/tmp ${INC_DIR}/metkit/metkit_config.h
	# Avoid conflict with different odb ( #880890) 
	mv debian/tmp/usr/bin/odb	debian/tmp/usr/bin/ecmwf_odb

=== debian/watch ===
version=3
https://software.ecmwf.int/wiki/display/ODBAPI/Releases /wiki/download/attachments/61117379/odb_api_bundle\-(.+)\-Source\.tar\.gz\?api=v2
